<?PHP

function e_activist_element_info(){

	return array(

		'ea_other' => array(
			'#base_type' => 'radio',
			'#input' => false,
			'#multiple' => FALSE,
			'#disabled' => FALSE,
			'#other_value' => NULL,
			'#process' => array('e_activist_ea_other_process'),
			'#element_validate' => array('e_activist_ea_other_validate'),
			'#theme' => 'ea_other',
			'#theme_wrappers' => array('form_element'),
			'#values' => array()
		),

		'ea_multi_text' => array(
			'#input' => false,
			'#multiple' => FALSE,
			'#disabled' => FALSE,
			'#process' => array('e_activist_ea_multi_text_process'),
			'#element_validate' => array('e_activist_ea_multi_text_validate'),
			'#theme' => 'ea_multi_text',
			'#theme_wrappers' => array('form_element'),
			'#values' => array()
		),

		'ea_multi_select' => array(
			'#input' => false,
			'#multiple' => FALSE,
			'#disabled' => FALSE,
			'#process' => array('e_activist_ea_multi_select_process'),
			'#element_validate' => array('e_activist_ea_multi_select_validate'),
			'#theme' => 'ea_multi_select',
			'#theme_wrappers' => array('form_element'),
			'#values' => array()
		)
	
	);
	
}

function e_activist_ea_other_process($element, &$form_state){
	$element['#tree'] = true;
	$element['#processed'] = true;

	$disabled = isset($element['#disabled']) ? $element['#disabled'] : false;
	
	$options = array();
	$selected = false;
	$otherSelected = false;
	
	foreach($element['#values'] as $option){
		$options[$option->value] = $option->label;
		if($option->selected){
			$selected = $option->value;
		}	
	}
	if(!$selected){
		$selected = reset($options);
	}
	if($selected == end($options)){
		$otherSelected = true;
	}
	
	
	$element[] = array(
		'#type' => $element['#base_type'],
		'#options' => $options,
		'#default_value' => $selected,
		'#theme_wrappers' => array(),
		'#disabled' => $disabled
	);
	
	$classes = array('ea-other');
	
	if(isset($element['#error']) && $element['#error']){
		$classes[] = 'error';
	}
	
	$element[] = array(
		'#type' => 'textfield',
		'#default_value' => $otherSelected ? $element['#other_value'] : '',
		'#size' => 15,
		'#attributes' => array('class' => $classes),
		'#theme_wrappers' => array(),
		'#disabled' => $disabled
	);
	
	return $element;
}

function e_activist_ea_other_validate(){
	
}

function e_activist_ea_multi_text_process($element, &$form_state){
	$element['#processed'] = true;
	$element['#tree'] = true;

	$disabled = isset($element['#disabled']) ? $element['#disabled'] : false;

	e_activist_field_register_remove($element['#fieldinfo']->name);
	
	foreach($element['#values'] as $key => $value){
		$enName = $element['#fieldinfo']->name . $key;
		$registeredField = e_activist_field_register($enName, $element['#fieldinfo']->secure);
		
		$classes = array('ea-multi');
		if(isset($element['#error']) && $element['#error']){
			$classes[] = 'error';
		}
		$element[] = array(
			'#type' => 'textfield',
			'#default_value' => $value,
			'#size' => 5,
			'#name' => $registeredField['drupalName'],
			'#attributes' => array('class' => $classes),
			'#theme_wrappers' => array(),
			'#disabled' => $disabled
		);
	}
	
	return $element;
	
}
function e_activist_ea_multi_text_validate(){
	
}


function e_activist_ea_multi_select_process($element, &$form_state){
	$element['#processed'] = true;
	$element['#tree'] = true;

	$disabled = isset($element['#disabled']) ? $element['#disabled'] : false;

	e_activist_field_register_remove($element['#fieldinfo']->name);
	
	foreach($element['#values'] as $key => $value){
		$enName = $element['#fieldinfo']->name . $key;
		$registeredField = e_activist_field_register($enName, $element['#fieldinfo']->secure);
		$options = array();
		$selected = null;
		foreach($value as $option){
			$options[$option->value] = $option->label;
			if($option->selected){
				$selected = $option->value;
			}
		}
		
		$classes = array('ea-multi');
		if(isset($element['#error']) && $element['#error']){
			$classes[] = 'error';
		}

		$element[] = array(
			'#type' => 'select',
			'#default_value' => $selected,
			'#options' => $options,
			'#name' => $registeredField['drupalName'],
			'#attributes' => array('class' => $classes),
			'#theme_wrappers' => array(),
			'#disabled' => $disabled
		);
	}

	return $element;
	
}

function e_activist_ea_multi_select_validate(){
	
}
