<?PHP


/** Sync functionality **/

function e_activist_get_sync_items(){
	$items = array();
	foreach (variable_get('campaigns_to_sync', array()) as $campaignInfo){
		list($client_id,$campaign_id) = explode("-", $campaignInfo);
		$items[] = array(
			'client_id' => $client_id,
			'campaign_id' => $campaign_id
		);
	}
	return $items;
}

function e_activist_cron(){
	$queue = DrupalQueue::get('e_activist_sync');

	$items = e_activist_get_sync_items();
	foreach ($items as $item) {
		$queue->createItem($item);
	}
}

function e_activist_cron_queue_info(){
	$queues['e_activist_sync'] = array(
		'worker callback' => 'e_activist_queue_item',
		'time' => 120,
	);
	return $queues;
}

function e_activist_queue_item($campaign){
	$node = e_activist_get_campaign_node($campaign['client_id'],$campaign['campaign_id']);
	// save node to trigger sync
	node_save($node);
}

function e_activist_campaigns_batch(){

	$batch = array(
		'title' => 'Importing selected campaigns',
		'operations' => array(),
		'finished' => 'e_activist_campaigns_batch_complete',
		'progress_message' => t('Campaigns remaining: @remaining | @percentage complete | Estimated time remaining: @estimate')

	);

	foreach (e_activist_get_sync_items() as $campaignInfo){
		$batch['operations'][] = array(
			'e_activist_campaigns_batch_item', array($campaignInfo)
		);
	}
	
	return $batch;
}

function e_activist_sync_form(){
	$form['instructions'] = array(
		'#markup' => '<p>Sync selected campaigns now?</p>'
	);
	$form['submit'] = array(
		'#type' => 'submit',
		'#value' => 'Sync'
	);
	return $form;
}

function e_activist_sync_form_submit($form, &$form_values){
	$batch = e_activist_campaigns_batch();
	batch_set($batch);
}

function e_activist_campaigns_batch_item($campaign, &$context){
	e_activist_queue_item($campaign);
}

